//------------ standard header -----------------------------------//
#include "stdlibrary.h"
//------------ end of standard header ----------------------------//
#include <stdarg.h>
#ifdef _WIN32
	#include <windows.h>
#endif
#include <gtk/gtk.h>
#include <gtkextra/gtkextra.h>
#include "AnsiString.h"
#include <stdlib.h>

#define PARAM_INT           Split(&param, ';', start).ToInt()
#define PARAM_DOUBLE        Split(&param, ';', start).ToFloat()
#define ANSI_PARAM_STR      Split(&param, 0, start)



#define CUSTOM_CONTROL_ID       1019

#define EVENT_ON_ACTIVATE            350
#define EVENT_ON_CHANGED             351
#define EVENT_ON_CLEARCELL           352
#define EVENT_ON_CLIPRANGE           353
#define EVENT_ON_DEACTIVATE          354
#define EVENT_ON_MOVERANGE           355
#define EVENT_ON_RESIZERANGE         356
#define EVENT_ON_SELECTCOLUMN        357
#define EVENT_ON_SELECTRANGE         358
#define EVENT_ON_SELECTROW           359
#define EVENT_ON_SETCELL             360
#define EVENT_ON_TRAVERSE            361


#define P_SHEET_ENTRYTYPE   1000
#define P_SHEET_VADJUSTMENT 1001
#define P_SHEET_HADJUSTMENT 1002
#define P_SHEET_STATE       1003
#define P_SHEET_RANGE       1004
#define P_SHEET_SELECTMODE  1005
#define P_SHEET_AUTORESIZE  1006
#define P_SHEET_AUTOSCROLL  1007
#define P_SHEET_CLIPTEXT    1008
#define P_SHEET_JUSTIFY     1009
#define P_SHEET_LOCKED      1010
#define P_SHEET_TITLE       1011
#define P_SHEET_FREEZE      1012
#define P_SHEET_THAW        1013
#define P_SHEET_BACKGROUND  1014
#define P_SHEET_GRIDCOLOR   1015
#define P_SHEET_GRIDVISIBLE 1016
#define P_SHEET_COLUMNTITLE 1017
#define P_SHEET_ROWTITLE    1018
#define P_SHEET_ROWBUTTONADD 1019
#define P_SHEET_COLBUTTONADD 1020
#define P_SHEET_ROWBUTTONJUST 1021
#define P_SHEET_COLBUTTONJUST 1022
#define P_SHEET_MOVETO      1023
#define P_SHEET_ROWTITLEVISIBLE 1024
#define P_SHEET_COLTITLEVISIBLE 1025
#define P_SHEET_COLVISIBLE  1026
#define P_SHEET_ROWVISIBLE  1027
#define P_SHEET_ROWSSENSITIVE 1028
#define P_SHEET_COLSSENSITIVE 1029
#define P_SHEET_ROWRESIZABLE 1030
#define P_SHEET_COLRESIZABLE 1031
#define P_SHEET_ROWSENSITIVE 1032
#define P_SHEET_COLSENSITIVE 1033
#define P_SHEET_SELECTROW   1034
#define P_SHEET_SELECTCOL   1035
#define P_SHEET_CLIPRANGE   1036
#define P_SHEET_UNCLIPRANGE 1037
#define P_SHEET_IN_CLIP     1038
#define P_SHEET_SELECTRANGE 1039
#define P_SHEET_UNSELECTRANGE 1040
#define P_SHEET_ACTIVECELL  1041
#define P_SHEET_CELL        1042
#define P_SHEET_CELLTEXT    1043
#define P_SHEET_CELLCLEAR   1044
#define P_SHEET_CELLDELETE  1045
#define P_SHEET_RANGECLEAR  1046
#define P_SHEET_RANGEDELETE 1047
#define P_SHEET_CELLSTATE   1048
#define P_SHEET_ROWHEIGHT   1049
#define P_SHEET_COLWIDTH    1050
#define P_SHEET_ADDCOL      1051
#define P_SHEET_ADDROW      1052
#define P_SHEET_INSERTCOL   1053
#define P_SHEET_INSERTROW   1054
#define P_SHEET_RANGE_BCOLOR 1055
#define P_SHEET_RANGE_FCOLOR 1056
#define P_SHEET_RANGE_EDITABLE 1057
#define P_SHEET_RANGE_VISIBLE 1058
#define P_SHEET_RANGE_BORDER 1059
#define P_SHEET_RANGE_BORDER_COLOR 1060
#define P_SHEET_RANGE_FONT  1061
#define P_SHEET_ATTACH      1062
#define P_SHEET_ATTACH_BUTTON 1063
#define P_SHEET_DELETE_COLUMNS 1064
#define P_SHEET_DELETE_ROWS 1065
#define P_SHEET_RANGE_JUST  1066

static INVOKER RemoteInvoker=0;
AnsiString GetPOST_STRING() {
    AnsiString res;
    char *post_string=0;
    int len_post_string=0;
    RemoteInvoker(0,INVOKE_GETPOSTSTRING,&post_string,&len_post_string);
    res.LoadBuffer(post_string, len_post_string);
    return res;
}

void on_activate(GtkSheet *sheet, gint row, gint column, void *user_data) {
    AnsiString event_data;
    event_data=AnsiString((long)row);
    event_data+=(char*)";";
    event_data+=AnsiString((long)column);
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_ACTIVATE, event_data.c_str());
    //return FALSE;
}

void on_changed(GtkSheet *sheet, gint row, gint column, void *user_data) {
    AnsiString event_data;
    event_data=AnsiString((long)row);
    event_data+=(char*)";";
    event_data+=AnsiString((long)column);
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_CHANGED, event_data.c_str());
    //return FALSE;
}

void on_clear_cell(GtkSheet *sheet, gint row, gint column, void *user_data) {
    AnsiString event_data;
    event_data=AnsiString((long)row);
    event_data+=(char*)";";
    event_data+=AnsiString((long)column);
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_CLEARCELL, event_data.c_str());
    //return FALSE;
}

void on_clip_range(GtkSheet *sheet, GtkSheetRange *range, void *user_data) {
    AnsiString event_data;
    event_data=AnsiString((long)range->row0);
    event_data+=(char*)";";
    event_data+=AnsiString((long)range->col0);
    event_data+=(char*)";";
    event_data+=AnsiString((long)range->rowi);
    event_data+=(char*)";";
    event_data+=AnsiString((long)range->coli);
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_CLIPRANGE, event_data.c_str());
    //return FALSE;
}

void on_deactivate(GtkSheet *sheet, gint row, gint column, void *user_data) {
    AnsiString event_data;
    event_data=AnsiString((long)row);
    event_data+=(char*)";";
    event_data+=AnsiString((long)column);
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_DEACTIVATE, event_data.c_str());
    //return TRUE;
}

void on_move_range(GtkSheet *sheet, GtkSheetRange *range, GtkSheetRange *destiny_range, void *user_data) {
    AnsiString event_data;
    event_data=AnsiString((long)range->row0);
    event_data+=(char*)";";
    event_data+=AnsiString((long)range->col0);
    event_data+=(char*)";";
    event_data+=AnsiString((long)range->rowi);
    event_data+=(char*)";";
    event_data+=AnsiString((long)range->coli);
    event_data+=(char*)";";
    event_data+=AnsiString((long)destiny_range->row0);
    event_data+=(char*)";";
    event_data+=AnsiString((long)destiny_range->col0);
    event_data+=(char*)";";
    event_data+=AnsiString((long)destiny_range->rowi);
    event_data+=(char*)";";
    event_data+=AnsiString((long)destiny_range->coli);
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_MOVERANGE, event_data.c_str());
    //return FALSE;
}

void on_resize_range(GtkSheet *sheet, GtkSheetRange *range, GtkSheetRange *new_range, void *user_data) {
    AnsiString event_data=AnsiString((long)range->row0);
    event_data+=(char*)";";
    event_data+=AnsiString((long)range->col0);
    event_data+=(char*)";";
    event_data+=AnsiString((long)range->rowi);
    event_data+=(char*)";";
    event_data+=AnsiString((long)range->coli);
    event_data+=(char*)";";
    event_data+=AnsiString((long)new_range->row0);
    event_data+=(char*)";";
    event_data+=AnsiString((long)new_range->col0);
    event_data+=(char*)";";
    event_data+=AnsiString((long)new_range->rowi);
    event_data+=(char*)";";
    event_data+=AnsiString((long)new_range->coli);
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_RESIZERANGE, event_data.c_str());
    //return FALSE;
}

void on_select_column(GtkSheet *sheet, gint col, void *user_data) {
    AnsiString event_data((long)col);
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_SELECTCOLUMN, event_data.c_str());
    //return FALSE;
}

void on_select_range(GtkSheet *sheet,  GtkSheetRange *range, void *user_data) {
    AnsiString event_data;
    event_data=AnsiString((long)range->row0);
    event_data+=(char*)";";
    event_data+=AnsiString((long)range->col0);
    event_data+=(char*)";";
    event_data+=AnsiString((long)range->rowi);
    event_data+=(char*)";";
    event_data+=AnsiString((long)range->coli);
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_SELECTRANGE, event_data.c_str());
    //return FALSE;
}

void on_select_row(GtkSheet *sheet, gint row, void *user_data) {
    AnsiString event_data((long)row);
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_SELECTROW, event_data.c_str());
    //return FALSE;
}

void on_set_cell(GtkSheet *sheet, gint row, gint column, void *user_data) {
    AnsiString event_data;
    event_data=AnsiString((long)row);
    event_data+=(char*)";";
    event_data+=AnsiString((long)column);
    event_data+=(char*)";";
    event_data+=AnsiString(gtk_sheet_cell_get_text(sheet, row, column));
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_SETCELL, event_data.c_str());
    //return FALSE;
}

void on_travers(GtkSheet *sheet, gint row, gint column, void *new_row, void *new_col, void *user_data) {
    AnsiString event_data;
    event_data=AnsiString((long)row);
    event_data+=(char*)";";
    event_data+=AnsiString((long)column);
    RemoteInvoker(user_data, INVOKE_FIREEVENT, (int)EVENT_ON_TRAVERSE, event_data.c_str());
    //return FALSE;
}

static AnsiString Split(AnsiString *s, char sep, int &start) {
    AnsiString res;
    int len=s->Length();
    char *buf=s->c_str();
    if (start<0)
        return res;
    for (;start<len;start++) {
        char c=buf[start];
        if (c==sep) {
            start++;
            return res;
        }
        res+=c;
    }
    start=-1;
    return res;
}

void Get4(double *a, double *b, double *c, double *d, char *ptr) {
    AnsiString post=ptr ? AnsiString(ptr) : GetPOST_STRING();
    int start=0;
    *a=Split(&post, ';', start).ToFloat();
    *b=Split(&post, ';', start).ToFloat();
    *c=Split(&post, ';', start).ToFloat();
    *d=Split(&post, ';', start).ToFloat();
}

void Get7(double *a, double *b, double *c, double *d, double *e, double *f, double *g, char *ptr) {
    AnsiString post=ptr ? AnsiString(ptr) : GetPOST_STRING();
    int start=0;
    *a=Split(&post, ';', start).ToFloat();
    *b=Split(&post, ';', start).ToFloat();
    *c=Split(&post, ';', start).ToFloat();
    *d=Split(&post, ';', start).ToFloat();
    *e=Split(&post, ';', start).ToFloat();
    *f=Split(&post, ';', start).ToFloat();
    *g=Split(&post, ';', start).ToFloat();
}

void Get3(double *a, double *b, double *c,char *ptr) {
    AnsiString post=ptr ? AnsiString(ptr) : GetPOST_STRING();
    int start=0;
    *a=Split(&post, ';', start).ToFloat();
    *b=Split(&post, ';', start).ToFloat();
    *c=Split(&post, ';', start).ToFloat();
}

void Get2(double *a, double *b, char *ptr) {
    AnsiString post=ptr ? AnsiString(ptr) : GetPOST_STRING();
    int start=0;
    *a=Split(&post, ';', start).ToFloat();
    *b=Split(&post, ';', start).ToFloat();
}

AnsiString Get3text(double *a, double *b, double *c, char *ptr) {
    AnsiString post=ptr ? AnsiString(ptr) : GetPOST_STRING();
    int start=0;
    *a=Split(&post, ';', start).ToFloat();
    *b=Split(&post, ';', start).ToFloat();
    *c=Split(&post, ';', start).ToFloat();
    return Split(&post, ';', start);
}
AnsiString Get2text(double *a, double *b, char *ptr) {
    AnsiString post=ptr ? AnsiString(ptr) : GetPOST_STRING();
    int start=0;
    *a=Split(&post, ';', start).ToFloat();
    *b=Split(&post, ';', start).ToFloat();
    return Split(&post, ';', start);
}

int GetRange(GtkSheetRange *range, char *ptr) {
    AnsiString post=ptr ? AnsiString(ptr) : GetPOST_STRING();
    int start=0;
    range->row0=Split(&post, ';', start).ToInt();
    range->col0=Split(&post, ';', start).ToInt();
    range->rowi=Split(&post, ';', start).ToInt();
    range->coli=Split(&post, ';', start).ToInt();
    return Split(&post, ';', start).ToInt();
}

AnsiString GetRangeFont(GtkSheetRange *range, char *ptr) {
    AnsiString post=ptr ? AnsiString(ptr) : GetPOST_STRING();
    int start=0;
    range->row0=Split(&post, ';', start).ToInt();
    range->col0=Split(&post, ';', start).ToInt();
    range->rowi=Split(&post, ';', start).ToInt();
    range->coli=Split(&post, ';', start).ToInt();
    return Split(&post, 0, start);
}


// Control invoker function
AnsiString buffered_text;
PREFIX int Invoke(void *context,int INVOKE_TYPE,...) {
    va_list arg;
    int start=0;
    switch (INVOKE_TYPE) {
        case INVOKE_QUERYTEST:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id=va_arg(arg, int);
                va_end(arg);

                if (cls_id==CUSTOM_CONTROL_ID)
                    return E_ACCEPTED;
            }
            break;
        case INVOKE_SETEVENT:
            {
                if (!RemoteInvoker)
                    break;
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                int event_id    =   va_arg(arg, int);
                char *str_buffer=   va_arg(arg, char *);
                int buf_len     =   va_arg(arg, int);
                va_end(arg);

                if ((!context) || (cls_id!=CUSTOM_CONTROL_ID))
                    break;

                GtkSheet *view=GTK_SHEET(context);

                switch (event_id) {
                    case EVENT_ON_ACTIVATE:
                    	g_signal_connect (view, "activate", G_CALLBACK (on_activate),context);
                        return E_ACCEPTED;
                    case EVENT_ON_CHANGED:
                    	g_signal_connect (view, "changed" , G_CALLBACK (on_changed),context);
                        return E_ACCEPTED;
                    case EVENT_ON_CLEARCELL:
                    	g_signal_connect (view, "clear-cell", G_CALLBACK (on_clear_cell),context);
                        return E_ACCEPTED;
                    case EVENT_ON_CLIPRANGE:
                    	g_signal_connect (view, "clip-range", G_CALLBACK (on_clip_range),context);
                        return E_ACCEPTED;
                    case EVENT_ON_DEACTIVATE:
                    	g_signal_connect (view, "deactivate", G_CALLBACK (on_deactivate),context);
                        return E_ACCEPTED;
                    case EVENT_ON_MOVERANGE:
                    	g_signal_connect (view, "move-range", G_CALLBACK (on_move_range),context);
                        return E_ACCEPTED;
                    case EVENT_ON_RESIZERANGE:
                    	g_signal_connect (view, "resize-range", G_CALLBACK (on_resize_range),context);
                        return E_ACCEPTED;
                    case EVENT_ON_SELECTCOLUMN:
                    	g_signal_connect (view, "select-column", G_CALLBACK (on_select_column),context);
                        return E_ACCEPTED;
                    case EVENT_ON_SELECTRANGE:
                    	g_signal_connect (view, "select-range", G_CALLBACK (on_select_range),context);
                        return E_ACCEPTED;
                    case EVENT_ON_SELECTROW:
                    	g_signal_connect (view, "select-row", G_CALLBACK (on_select_row),context);
                        return E_ACCEPTED;
                    case EVENT_ON_SETCELL:
                    	g_signal_connect (view, "set-cell", G_CALLBACK (on_set_cell),context);
                        return E_ACCEPTED;
                    case EVENT_ON_TRAVERSE:
                    	g_signal_connect (view, "traverse", G_CALLBACK (on_travers),context);
                        return E_ACCEPTED;
                }
            }
            break;
        case INVOKE_SETPROPERTY:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                int prop_id     =   va_arg(arg, int);
                char *str_buffer=   va_arg(arg, char *);
                int buf_len     =   va_arg(arg, int);
                va_end(arg);

                if ((!context) || (cls_id!=CUSTOM_CONTROL_ID))
                    break;

                AnsiString param;
                param.LoadBuffer(str_buffer, buf_len);

                GtkSheet *view=GTK_SHEET(context);
                switch (prop_id) {
                    case P_SHEET_ENTRYTYPE:
                        gtk_sheet_change_entry(view, param.ToInt());
                        break;
                    case P_SHEET_VADJUSTMENT:
                        {
                            int ctrl_id=param.ToInt();
                            int cls_id=0;
                            void *object=0;
                            if (ctrl_id>0) {
                                RemoteInvoker(context,INVOKE_GETCONTROL, ctrl_id, &object, &cls_id);
                                if (cls_id>0)
                                    gtk_sheet_set_vadjustment(view, GTK_ADJUSTMENT(object));
                            }
                        }
                        break;
                    case P_SHEET_HADJUSTMENT:
                        {
                            int ctrl_id=param.ToInt();
                            int cls_id=0;
                            void *object=0;
                            if (ctrl_id>0) {
                                RemoteInvoker(context,INVOKE_GETCONTROL, ctrl_id, &object, &cls_id);
                                if (cls_id>0)
                                    gtk_sheet_set_hadjustment(view, GTK_ADJUSTMENT(object));
                            }
                        }
                        break;
                    case P_SHEET_STATE:
                        break;
                    case P_SHEET_RANGE:
                        break;
                    case P_SHEET_SELECTMODE:
                        gtk_sheet_set_selection_mode(view, (GtkSelectionMode)param.ToInt());
                        break;
                    case P_SHEET_AUTORESIZE:
                        gtk_sheet_set_autoresize(view, param.ToInt());
                        break;
                    case P_SHEET_AUTOSCROLL:
                        gtk_sheet_set_autoscroll(view, param.ToInt());
                        break;
                    case P_SHEET_CLIPTEXT:
                        gtk_sheet_set_clip_text(view, param.ToInt());
                        break;
                    case P_SHEET_JUSTIFY:
                        gtk_sheet_set_justify_entry(view, param.ToInt());
                        break;
                    case P_SHEET_LOCKED:
                        gtk_sheet_set_locked(view, param.ToInt());
                        break;
                    case P_SHEET_TITLE:
                        gtk_sheet_set_title(view, param.c_str());
                        break;
                    case P_SHEET_FREEZE:
                        if (param.ToInt())
                            gtk_sheet_freeze(view);
                        break;
                    case P_SHEET_THAW:
                        if (param.ToInt())
                            gtk_sheet_thaw(view);
                        break;
                    case P_SHEET_BACKGROUND:
                        {
                            int color=param.ToInt();
                            int red=color/0x10000;
                            color%=0x10000;
                            int green=color/0x100;
                            color%=0x100;
                            int blue=color;
                            GdkColor uset_color;
                            uset_color.pixel=0;
                            uset_color.red=((unsigned short)red*0xFF);
                            uset_color.green=((unsigned short)green*0xFF);
                            uset_color.blue=((unsigned short)blue*0xFF);
                            gdk_color_alloc(gdk_colormap_get_system(),&uset_color);
                            gtk_sheet_set_background(view, &uset_color);
                        }
                        break;
                    case P_SHEET_GRIDCOLOR:
                        {
                            int color=param.ToInt();
                            int red=color/0x10000;
                            color%=0x10000;
                            int green=color/0x100;
                            color%=0x100;
                            int blue=color;
                            GdkColor uset_color;
                            uset_color.pixel=0;
                            uset_color.red=((unsigned short)red*0xFF);
                            uset_color.green=((unsigned short)green*0xFF);
                            uset_color.blue=((unsigned short)blue*0xFF);
                            gdk_color_alloc(gdk_colormap_get_system(),&uset_color);
                            gtk_sheet_set_grid(view, &uset_color);
                        }
                        break;
                    case P_SHEET_GRIDVISIBLE:
                        {
                            GValue dest_value= { 0, };
                            g_value_init(&dest_value, G_TYPE_BOOLEAN);
                            g_value_set_boolean(&dest_value, param.ToInt());
                            g_object_set_property(G_OBJECT(view), "grid-visible", &dest_value);
                        }
                        break;
                    case P_SHEET_COLUMNTITLE:
                        {
                            int pint=PARAM_INT;
                            AnsiString res=Split(&param, 0, start);
                            gtk_sheet_set_column_title(view, pint, res.c_str());
                        }
                        break;
                    case P_SHEET_ROWTITLE:
                        {
                            int pint=PARAM_INT;
                            AnsiString res=Split(&param, 0, start);
                            gtk_sheet_set_row_title(view, pint, res.c_str());
                        }
                        break;
                    case P_SHEET_ROWBUTTONADD:
                        {
                            int pint=PARAM_INT;
                            AnsiString res=Split(&param, 0, start);
                            gtk_sheet_row_button_add_label(view, pint, res.c_str());
                        }
                        break;
                    case P_SHEET_COLBUTTONADD:
                        {
                            int pint=PARAM_INT;
                            AnsiString res=Split(&param, 0, start);
                            gtk_sheet_column_button_add_label(view, pint, res.c_str());
                        }
                        break;
                    case P_SHEET_ROWBUTTONJUST:
                        {
                            int a=PARAM_INT;
                            int b=PARAM_INT;
                            gtk_sheet_row_button_justify(view, a, (GtkJustification)b);
                        }
                        break;
                    case P_SHEET_COLBUTTONJUST:
                        {
                            int a=PARAM_INT;
                            int b=PARAM_INT;
                            gtk_sheet_column_button_justify(view, a, (GtkJustification)b);
                        }
                        break;
                    case P_SHEET_MOVETO:
                        {
                            double a,b,c,d;
                            Get4(&a,&b,&c,&d, param.c_str());
                            gtk_sheet_moveto(view, (int)a,(int)b,c,d);
                        }
                        break;
                    case P_SHEET_ROWTITLEVISIBLE:
                        {
                            int a=PARAM_INT;
                            int b=PARAM_INT;
                            gtk_sheet_row_label_set_visibility(view, a, b);
                        }
                        break;
                    case P_SHEET_COLTITLEVISIBLE:
                        {
                            int a=PARAM_INT;
                            int b=PARAM_INT;
                            gtk_sheet_column_label_set_visibility(view, a, b);
                        }
                        break;
                    case P_SHEET_COLVISIBLE:
                        {
                            int a=PARAM_INT;
                            int b=PARAM_INT;
                            gtk_sheet_column_label_set_visibility(view, a, b);
                        }
                        break;
                    case P_SHEET_ROWVISIBLE:
                        {
                            int a=PARAM_INT;
                            int b=PARAM_INT;
                            gtk_sheet_row_set_visibility(view, a, b);
                        }
                        break;
                    case P_SHEET_ROWSSENSITIVE:
                        gtk_sheet_rows_set_sensitivity(view, param.ToInt());
                        break;
                    case P_SHEET_COLSSENSITIVE:
                        gtk_sheet_columns_set_sensitivity(view, param.ToInt());
                        break;
                    case P_SHEET_ROWRESIZABLE:
                        gtk_sheet_rows_set_resizable(view, param.ToInt());
                        break;
                    case P_SHEET_COLRESIZABLE:
                        gtk_sheet_columns_set_resizable(view, param.ToInt());
                        break;
                    case P_SHEET_ROWSENSITIVE:
                        {
                            int a=PARAM_INT;
                            int b=PARAM_INT;
                            gtk_sheet_row_set_sensitivity(view, a, b);
                        }
                        break;
                    case P_SHEET_DELETE_COLUMNS:
                        {
                            int a=PARAM_INT;
                            int b=PARAM_INT;
                            gtk_sheet_delete_columns(view, a, b);
                        }
                        break;
                    case P_SHEET_DELETE_ROWS:
                        {
                            int a=PARAM_INT;
                            int b=PARAM_INT;
                            gtk_sheet_delete_rows(view, a, b);
                        }
                        break;
                    case P_SHEET_COLSENSITIVE:
                        {
                            int a=PARAM_INT;
                            int b=PARAM_INT;
                            gtk_sheet_column_set_sensitivity(view, a, b);
                        }
                        break;
                    case P_SHEET_SELECTROW:
                        gtk_sheet_select_row(view, param.ToInt());
                        break;
                    case P_SHEET_SELECTCOL:
                        gtk_sheet_select_column(view, param.ToInt());
                        break;
                    case P_SHEET_CLIPRANGE:
                        {
                            GtkSheetRange range;
                            GetRange(&range, param.c_str());
                            gtk_sheet_clip_range(view, &range);
                        }
                        break;
                    case P_SHEET_UNCLIPRANGE:
                        if (param.ToInt())
                            gtk_sheet_unclip_range(view);
                        break;
                    case P_SHEET_IN_CLIP:
                        break;
                    case P_SHEET_SELECTRANGE:
                        {
                            GtkSheetRange range;
                            GetRange(&range, param.c_str());
                            gtk_sheet_select_range(view, &range);
                        }
                        break;
                    case P_SHEET_UNSELECTRANGE:
                        if (param.ToInt())
                            gtk_sheet_unselect_range(view);
                        break;
                    case P_SHEET_ACTIVECELL:
                        {
                            double a,b;
                            Get2(&a,&b,param.c_str());
                            gtk_sheet_set_active_cell(view,(int)a,(int)b);
                        }
                        break;
                    case P_SHEET_CELL:
                        {
                            double a,b,c;
                            AnsiString s=Get3text(&a, &b, &c, param.c_str());
                            gtk_sheet_set_cell(view,(int)a,(int)b,(GtkJustification)(int)c, s.c_str());
                        }
                        break;
                    case P_SHEET_CELLTEXT:
                        {
                            double a,b;
                            AnsiString s=Get2text(&a, &b, param.c_str());
                            gtk_sheet_set_cell_text(view,(int)a,(int)b,s.c_str());
                        }
                        break;
                    case P_SHEET_CELLCLEAR:
                        {
                            double a,b;
                            Get2(&a, &b, param.c_str());
                            gtk_sheet_cell_clear(view,(int)a,(int)b);
                        }
                        break;
                    case P_SHEET_CELLDELETE:
                        {
                            double a,b;
                            Get2(&a, &b, param.c_str());
                            gtk_sheet_cell_delete(view,(int)a,(int)b);
                        }
                        break;
                    case P_SHEET_RANGECLEAR:
                        {
                            GtkSheetRange range;
                            GetRange(&range, param.c_str());
                            gtk_sheet_range_clear(view, &range);
                        }
                        break;
                    case P_SHEET_RANGEDELETE:
                        {
                            GtkSheetRange range;
                            GetRange(&range, param.c_str());
                            gtk_sheet_range_delete(view, &range);
                        }
                        break;
                    case P_SHEET_CELLSTATE:
                        break;
                    case P_SHEET_ROWHEIGHT:
                        {
                            int col=PARAM_INT;
                            int size=PARAM_INT;
                            gtk_sheet_set_row_height(view, col, size);
                        }
                        break;
                    case P_SHEET_COLWIDTH:
                        {
                            int col=PARAM_INT;
                            int size=PARAM_INT;
                            gtk_sheet_set_column_width(view, col, size);
                        }
                        break;
                    case P_SHEET_ADDCOL:
                        gtk_sheet_add_column(view, param.ToInt());
                        break;
                    case P_SHEET_ADDROW:
                        gtk_sheet_add_row(view, param.ToInt());
                        break;
                    case P_SHEET_INSERTCOL:
                        {
                            int a=PARAM_INT;
                            int b=PARAM_INT;
                            gtk_sheet_insert_columns(view, a, b);
                        }
                        break;
                    case P_SHEET_INSERTROW:
                        {
                            int a=PARAM_INT;
                            int b=PARAM_INT;
                            gtk_sheet_insert_rows(view, a, b);
                        }
                        break;
                    case P_SHEET_RANGE_BCOLOR:
                        {
                            GtkSheetRange range;
                            int color=GetRange(&range, param.c_str());
                            int red=color/0x10000;
                            color%=0x10000;
                            int green=color/0x100;
                            color%=0x100;
                            int blue=color;
                            GdkColor uset_color;
                            uset_color.red=((unsigned short)red*0xFF);
                            uset_color.green=((unsigned short)green*0xFF);
                            uset_color.blue=((unsigned short)blue*0xFF);
                            gdk_color_alloc(gdk_colormap_get_system(),&uset_color);
                            gtk_sheet_range_set_background(view, &range, &uset_color);
                        }
                        break;
                    case P_SHEET_RANGE_FCOLOR:
                        {
                            GtkSheetRange range;
                            int color=GetRange(&range, param.c_str());
                            int red=color/0x10000;
                            color%=0x10000;
                            int green=color/0x100;
                            color%=0x100;
                            int blue=color;
                            GdkColor uset_color;
                            uset_color.pixel=0;
                            uset_color.red=((unsigned short)red*0xFF);
                            uset_color.green=((unsigned short)green*0xFF);
                            uset_color.blue=((unsigned short)blue*0xFF);
                            gdk_color_alloc(gdk_colormap_get_system(),&uset_color);
                            gtk_sheet_range_set_foreground(view, &range, &uset_color);
                        }
                        break;
                    case P_SHEET_RANGE_EDITABLE:
                        {
                            GtkSheetRange range;
                            int editable=GetRange(&range,param.c_str());
                            gtk_sheet_range_set_editable(view, &range, editable);
                        }
                        break;
                    case P_SHEET_RANGE_VISIBLE:
                        {
                            GtkSheetRange range;
                            int flag=GetRange(&range,param.c_str());
                            gtk_sheet_range_set_visible(view, &range, flag);
                        }
                        break;
                    case P_SHEET_RANGE_BORDER:
                        {
                            GtkSheetRange range;
                            GetRange(&range,0);
                            double a,b,c;
                            Get3(&a,&b,&c,param.c_str());
                            gtk_sheet_range_set_border(view, &range, (int)a, (int)b, int(c));
                        }
                        break;
                    case P_SHEET_RANGE_JUST:
                        {
                            GtkSheetRange range;
                            GetRange(&range,0);
                            gtk_sheet_range_set_justification(view, &range, (GtkJustification)(param.ToInt()));
                        }
                        break;
                    case P_SHEET_RANGE_BORDER_COLOR:
                        {
                            GtkSheetRange range;
                            int color=GetRange(&range, param.c_str());
                            int red=color/0x10000;
                            color%=0x10000;
                            int green=color/0x100;
                            color%=0x100;
                            int blue=color;
                            GdkColor uset_color;
                            uset_color.pixel=0;
                            uset_color.red=((unsigned short)red*0xFF);
                            uset_color.green=((unsigned short)green*0xFF);
                            uset_color.blue=((unsigned short)blue*0xFF);
                            gdk_color_alloc(gdk_colormap_get_system(),&uset_color);
                            gtk_sheet_range_set_border_color (view, &range, &uset_color);
                        }
                        break;
                    case P_SHEET_RANGE_FONT:
                        {
                            GtkSheetRange range;
                            AnsiString font=GetRangeFont(&range, param.c_str());
                            gtk_sheet_range_set_font(view, &range, pango_font_description_from_string(font.c_str()));
                        }
                        break;
                    case P_SHEET_ATTACH:
                        {
                            int cls_id=0;
                            void *object=0;
                            double a,b,c,d,e,f,g;
                            Get7(&a,&b,&c,&d,&e,&f,&g,param.c_str());
                            int ctrl_id=(int)g;
                            if (ctrl_id>0) {
                                RemoteInvoker(context,INVOKE_GETCONTROL, ctrl_id, &object, &cls_id);
                                if (cls_id>0)
                                    gtk_sheet_attach(view, GTK_WIDGET(object), (int)a, (int)b, (int)c, (int)d, (int)e, (int)f);
                            }
                        }
                        break;
                    case P_SHEET_ATTACH_BUTTON:
                        {
                            int cls_id=0;
                            void *object=0;
                            double a,b,c;
                            Get3(&a,&b,&c,param.c_str());
                            int ctrl_id=(int)c;
                            if (ctrl_id>0) {
                                RemoteInvoker(context,INVOKE_GETCONTROL, ctrl_id, &object, &cls_id);
                                if (cls_id>0)
                                    gtk_sheet_button_attach(view, GTK_WIDGET(object), (int)a, (int)b);
                            }
                        }
                        break;
                    default:
                        return E_NOTIMPLEMENTED;
                }
                
                return E_NOERROR;
            }
            break;
        case INVOKE_GETPROPERTY:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                int prop_id     =   va_arg(arg, int);
                char **str_buffer=   va_arg(arg, char **);
                int *buf_len     =   va_arg(arg, int*);
                va_end(arg);

                if ((!context) || (cls_id!=CUSTOM_CONTROL_ID))
                    break;


                GtkSheet *view=GTK_SHEET(context);
                switch (prop_id) {
                    case P_SHEET_STATE:
                        buffered_text=AnsiString((long)gtk_sheet_get_state(view));
                        *str_buffer=buffered_text.c_str();
                        *buf_len=buffered_text.Length();
                        return E_ACCEPTED;
                    case P_SHEET_RANGE:
                        {
                            GtkSheetRange range;
                            gtk_sheet_get_visible_range(view, &range);
                            buffered_text=(char *)"";
                            buffered_text+=AnsiString((long)range.row0);
                            buffered_text+=(char *)";";
                            buffered_text+=AnsiString((long)range.col0);
                            buffered_text+=(char *)";";
                            buffered_text+=AnsiString((long)range.rowi);
                            buffered_text+=(char *)";";
                            buffered_text+=AnsiString((long)range.coli);
                            *str_buffer=buffered_text.c_str();
                            *buf_len=buffered_text.Length();
                        }
                        return E_ACCEPTED;
                    case P_SHEET_SELECTRANGE:
                        {
                            GtkSheetRange *range=0;

                            g_object_get(G_OBJECT(view), "selected-range", &range, NULL);

                            if (!range) {
                                buffered_text=(char *)"-1;-1;-1;-1;";
                                *str_buffer=buffered_text.c_str();
                                *buf_len=buffered_text.Length();

                                return E_ACCEPTED;
                            }
                            buffered_text=(char *)"";
                            buffered_text+=AnsiString((long)range->row0);
                            buffered_text+=(char *)";";
                            buffered_text+=AnsiString((long)range->col0);
                            buffered_text+=(char *)";";
                            buffered_text+=AnsiString((long)range->rowi);
                            buffered_text+=(char *)";";
                            buffered_text+=AnsiString((long)range->coli);
                            *str_buffer=buffered_text.c_str();
                            *buf_len=buffered_text.Length();
                            if (range)
                                free(range);
                        }
                        return E_ACCEPTED;
                    case P_SHEET_COLUMNTITLE:
                        {
                            buffered_text=(char *)gtk_sheet_get_column_title(view, GetPOST_STRING().ToInt());
                            *str_buffer=buffered_text.c_str();
                            *buf_len=buffered_text.Length();
                        }
                        return E_ACCEPTED;
                    case P_SHEET_ROWTITLE:
                        {
                            buffered_text=(char *)gtk_sheet_get_row_title(view, GetPOST_STRING().ToInt());
                            *str_buffer=buffered_text.c_str();
                            *buf_len=buffered_text.Length();
                        }
                        return E_ACCEPTED;
                    case P_SHEET_IN_CLIP:
                        {
                            buffered_text=AnsiString((long)gtk_sheet_in_clip(view));
                            *str_buffer=buffered_text.c_str();
                            *buf_len=buffered_text.Length();
                        }
                        return E_ACCEPTED;
                    case P_SHEET_CELLTEXT:
                        {
                            double a,b;
                            Get2(&a,&b,0);
                            char *ptr=(char *)gtk_sheet_cell_get_text(view, (int)a, (int)b);
                            if (ptr) {
                                buffered_text=ptr;
                                *str_buffer=buffered_text.c_str();
                                *buf_len=buffered_text.Length();
                            } else {
                                buffered_text=(char *)"";
                                *str_buffer=buffered_text.c_str();
                                *buf_len=0;
                            }                            
                        }
                        return E_ACCEPTED;
                    case P_SHEET_CELLSTATE:
                        {
                            double a,b;
                            Get2(&a,&b,0);
                            buffered_text=AnsiString((long)gtk_sheet_cell_get_state(view, (int)a, (int)b));
                            *str_buffer=buffered_text.c_str();
                            *buf_len=buffered_text.Length();
                            
                        }
                        return E_ACCEPTED;
                    case P_SHEET_ACTIVECELL:
                        {
                            int a,b;
                            gtk_sheet_get_active_cell(view,&a,&b);
                            buffered_text=AnsiString((long)a);
                            buffered_text+=(char *)";";
                            buffered_text+=AnsiString((long)b);
                            *str_buffer=buffered_text.c_str();
                            *buf_len=buffered_text.Length();
                        }
                        return E_ACCEPTED;
                    default:
                        return E_NOTIMPLEMENTED;
                }
                
                return E_NOERROR;
            }
            break;
        case INVOKE_SETSTREAM:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                char *target    =   va_arg(arg, char *);
                int len_target  =   va_arg(arg, int);
                char *value     =   va_arg(arg, char *);
                int len_value   =   va_arg(arg, int);
                va_end(arg);

                return E_NOERROR;
            }
            break;
        case INVOKE_SETSECONDARYSTREAM:
            // not needed
            break;
        case INVOKE_CUSTOMMESSAGE:
            {
            }
            break;
        case INVOKE_CREATE:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                void **handler  =   va_arg(arg, void **);
                int *pack_type  =   va_arg(arg, int *);
                va_end(arg);
                *pack_type=(int)0;

                if (cls_id!=CUSTOM_CONTROL_ID)
                    break;

                AnsiString ps=GetPOST_STRING();
                int start=0;
                int editable=Split(&ps,';',start).ToInt();
                int rows=Split(&ps,';',start).ToInt();
                int columns=Split(&ps,';',start).ToInt();
                AnsiString title=Split(&ps,0,start);
                GtkWidget *widget=0;
                if (editable)
                    widget=gtk_sheet_new(rows,columns, title.c_str());
                else
                    widget=gtk_sheet_new_browser(rows,columns, title.c_str());
                gtk_sheet_set_hadjustment(GTK_SHEET(widget), GTK_ADJUSTMENT(gtk_adjustment_new(0.0,0.0,100.0,1.0,1.0,1.0)));
                gtk_sheet_set_vadjustment(GTK_SHEET(widget), GTK_ADJUSTMENT(gtk_adjustment_new(0.0,0.0,100.0,1.0,1.0,1.0)));
                *handler=widget;
                return E_ACCEPTED;
            }
            break;
        case INVOKE_DESTROY:
            {
                va_start(arg, INVOKE_TYPE);
                int cls_id      =   va_arg(arg, int);
                void *handler  =   va_arg(arg, void *);
                va_end(arg);

                if (cls_id!=CUSTOM_CONTROL_ID)
                    break;

                return E_ACCEPTED;
            }
            break;
        case INVOKE_INITLIBRARY:
            va_start(arg, INVOKE_TYPE);
            RemoteInvoker     =   va_arg(arg, INVOKER);
            va_end(arg);
            return E_NOERROR;

        case INVOKE_DONELIBRARY:
            return E_NOERROR;

        default:
            return E_NOTIMPLEMENTED;
    }
    return E_NOTIMPLEMENTED;
}


