#ifndef __PROPERTIES_PANEL_H
#define __PROPERTIES_PANEL_H

#include "ConceptClient.h"

#include <gtk/gtk.h>
#include "AnsiString.h"
#include "AnsiList.h"
#include "xmlParser.h"

#define PROP_INSTANT    0x01
#define PROP_OPTION     0x02
#define PROP_OPTIONEDIT 0x03
#define PROP_COLOR      0x04
#define PROP_FONT       0x05
#define PROP_FILE       0x06
#define PROP_STATIC     0x07

typedef struct {
    AnsiString name;
    AnsiString value;
    char type;
    char changed;
    GtkWidget *renderer;
} LocalProperty;

class PropertiesPanel {
private:
    AnsiList Properties;
    GtkTable *pTable;
    CConceptClient *CC;
    PangoFontDescription *font;
    AnsiString ID;
public:
    GtkVBox *handle;
    static gboolean changed_cbe(GtkComboBox *widget, gpointer user_data);
    static gboolean color_set(GtkWidget *widget, gpointer user_data);
    static gboolean font_set(GtkWidget *widget, gpointer user_data);
    static gboolean custom_click(GtkWidget *widget, gpointer user_data);

    virtual void changed(bool recursive);
    static gboolean focus_out_event(GtkWidget *widget, GdkEventFocus *event, gpointer user_data);
    static gboolean key_press_event(GtkWidget *widget, GdkEventKey *event, gpointer user_data);
    void MapOnChangeEvent(CConceptClient *_CC, int _ID);
    /*
    <pr>
            <pp n="proname" t=type v="test1"/0>
                <o>test1</o>
                <o>test2</o>
                <o>test3</o>
            </pp>
    </pr>
    */
    
    void SetProperties(AnsiString prop_xml);

    AnsiString GetPropertiesValues();
    AnsiString GetChangedPropertiesValues();


    PropertiesPanel();
    ~PropertiesPanel();
};

#endif // __PROPERTIES_PANEL_H
