#include "console.h"
#include "AnsiString.h"
#include "ConceptClient.h"


ConsoleWindow::ConsoleWindow(CB_IDLE cb, bool deletable) {
    //handle=GTK_WINDOW(gtk_window_new(GTK_WINDOW_TOPLEVEL));
    handle=GTK_WINDOW(gtk_dialog_new());
    //set_auto_startup_notification(false);
    gtk_window_set_title(handle, "Console");
    gtk_window_set_resizable(handle, true);
    gtk_window_set_decorated(handle, true);
    gtk_window_set_position(handle, GTK_WIN_POS_CENTER);
    this->cb=cb;
    gtk_window_set_default_size(handle, 600,400);

    wnd1=GTK_SCROLLED_WINDOW(gtk_scrolled_window_new(GTK_ADJUSTMENT(gtk_adjustment_new(0.0,0.0,100.0,1.0,1.0,1.0)), GTK_ADJUSTMENT(gtk_adjustment_new(0.0,0.0,100.0,1.0,1.0,1.0))));
    gtk_scrolled_window_set_policy(wnd1, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    //gtk_container_add(GTK_CONTAINER(handle), GTK_WIDGET(wnd1));
    gtk_container_add(GTK_CONTAINER(gtk_dialog_get_content_area(GTK_DIALOG(handle))), GTK_WIDGET(wnd1));
    gtk_widget_show(GTK_WIDGET(wnd1));

    gtk_dialog_set_has_separator(GTK_DIALOG(handle), FALSE);
    gtk_widget_hide(GTK_WIDGET(gtk_dialog_get_action_area(GTK_DIALOG(handle))));


    stdoutput=GTK_TEXT_VIEW(gtk_text_view_new());
    gtk_text_view_set_editable(stdoutput, false);
    gtk_text_view_set_cursor_visible(stdoutput, false);
    gtk_text_view_set_wrap_mode(stdoutput, GTK_WRAP_WORD);
    gtk_text_view_set_left_margin(stdoutput, 10);
    gtk_text_view_set_right_margin(stdoutput, 10);
    gtk_widget_show(GTK_WIDGET(stdoutput));

    GtkTextBuffer *refTextBuffer = gtk_text_view_get_buffer(stdoutput);
    GtkTextIter range_end;
    gtk_text_buffer_get_end_iter(refTextBuffer, &range_end);

    gtk_text_buffer_create_mark(refTextBuffer, "tail", &range_end, false);

    gtk_container_add(GTK_CONTAINER(wnd1), GTK_WIDGET(stdoutput));
    img=0;

    new_data=false;
    done=false;
    rerun=false;

    //if (!deletable) {
                g_signal_connect(
                           G_OBJECT(handle), 
                           "delete-event", 
                           G_CALLBACK(ConsoleWindow::on_delete), 
                           this
                );
    //}
    this->deletable=deletable;
    this->deleted=false;
    //gtk_widget_show_all(GTK_WIDGET(handle));
}

void ConsoleWindow::show() {
    gtk_widget_show(GTK_WIDGET(handle));
}

void ConsoleWindow::set_deletable(bool deletable) {
    this->deletable=deletable;
    if (!deletable) {
        g_signal_connect(
                   G_OBJECT(handle), 
                   "delete-event", 
                   G_CALLBACK(ConsoleWindow::on_delete), 
                   this
        );
    }
}

void ConsoleWindow::hide() {
    gtk_dialog_response (GTK_DIALOG(handle), GTK_RESPONSE_OK);
    gtk_widget_hide(GTK_WIDGET(handle));
}

void ConsoleWindow::ShowImage(char *path) {
    GtkImage *img=GTK_IMAGE(gtk_image_new());
    gtk_image_set_from_file(img, path);

    GtkTextBuffer *refTextBuffer = gtk_text_view_get_buffer(stdoutput);
    GtkTextIter range_begin;
    gtk_text_buffer_get_start_iter(refTextBuffer, &range_begin);

    GtkTextChildAnchor *refAnchor = gtk_text_buffer_create_child_anchor(refTextBuffer, &range_begin);

    gtk_text_view_add_child_at_anchor(stdoutput, GTK_WIDGET(img), refAnchor);

    gtk_widget_show(GTK_WIDGET(img));
    DirectPrint("\n");
    this->img=img;
}

void ConsoleWindow::HideImage() {
    if (img) {
        gtk_widget_hide(GTK_WIDGET(img));
    }
}
void ConsoleWindow::Print(char *text) {
    while (new_data)
        Sleep(1);
    new_data=true;
    this->text=text;
}

void ConsoleWindow::destroy() {
    gtk_widget_destroy(GTK_WIDGET(handle));
}

void ConsoleWindow::done_wnd(bool done) {
    gtk_dialog_response (GTK_DIALOG(handle), GTK_RESPONSE_OK);
    gtk_widget_hide(GTK_WIDGET(handle));
    this->done=done;
    this->rerun=false;
}

void ConsoleWindow::DirectPrint(char *text) {
    /*Gtk::Adjustment *adj=wnd1->get_vadjustment();

    bool scroll=false;
    double val=adj->get_value();
    if ((val==adj->get_upper()) || (val==0.0f)) {
        scroll=true;
    }*/

    if (img)
        HideImage();

    GtkTextBuffer *refTextBuffer = gtk_text_view_get_buffer(stdoutput);
    GtkTextIter range_end;
    gtk_text_buffer_get_end_iter(refTextBuffer, &range_end);
    if (text)
        gtk_text_buffer_insert(refTextBuffer, &range_end, text, strlen(text));


    GtkTextIter range_end2;
    gtk_text_buffer_get_end_iter(refTextBuffer, &range_end2);

    gtk_text_buffer_move_mark_by_name(refTextBuffer, "tail", &range_end2);

    GtkTextMark *mark=gtk_text_buffer_get_mark(refTextBuffer,"tail");

    gtk_text_view_scroll_to_mark(stdoutput, mark, 0, FALSE, 0.0, 0.0);
}

void ConsoleWindow::CloneData(ConsoleWindow *cw) {
    GtkTextBuffer *refTextBuffer = gtk_text_view_get_buffer(cw->stdoutput);
    GtkTextIter range_begin;
    gtk_text_buffer_get_start_iter(refTextBuffer, &range_begin);
    GtkTextIter range_end;
    gtk_text_buffer_get_end_iter(refTextBuffer, &range_end);
    DirectPrint((char *)gtk_text_buffer_get_text(refTextBuffer, &range_begin, &range_end,FALSE));
}

bool ConsoleWindow::my_idle2() {
    cb();
    if (new_data) {
        DirectPrint(text);
        new_data=false;
    } else
    if (done) {
        done=false;
        return true;
    }
    return false;
}

void ConsoleWindow::run() {
    do {
        gtk_dialog_run(GTK_DIALOG(handle));
    } while ((rerun) && (!done));
}

gboolean ConsoleWindow::on_delete(GtkWidget *Sender, GdkEventAny* event, gpointer user_data) {
    ConsoleWindow *TCW=(ConsoleWindow *)user_data;

    if (TCW->deletable) {
        gtk_widget_hide(GTK_WIDGET(TCW->handle));
        TCW->rerun=false;
        return TRUE;
    }

    GtkWidget *dialog=gtk_message_dialog_new(TCW->handle, GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_YES_NO, "%s","Are you sure you want to close this application ?");
    gtk_window_set_keep_above(GTK_WINDOW(dialog), TRUE);
    gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
    gtk_message_dialog_format_secondary_text(GTK_MESSAGE_DIALOG(dialog), "%s", "Is not recommended to close the application at this stage.\nYou should close only if the application failed to start,\n or took longer to start than the usual time.\n\nEven so, is possible to be an not-compiled application, and you should wait to compile it.");
    bool res=(gtk_dialog_run(GTK_DIALOG(dialog))!=GTK_RESPONSE_YES);
    gtk_widget_hide(GTK_WIDGET(dialog));

    if (res) {
        TCW->deleted=false;
        TCW->rerun=true;
    } else {
        TCW->deleted=true;
        TCW->rerun=false;
    }
    return TCW->rerun;//res;
    //return true;
}
    
ConsoleWindow::~ConsoleWindow() {
}
