#include "login.h"

LoginDialog::LoginDialog(char *image_file) {
		user_box=GTK_HBOX(gtk_hbox_new(false, 5));
        gtk_widget_show(GTK_WIDGET(user_box));
		top_box=GTK_HBOX(gtk_hbox_new(false, 5));
        gtk_widget_show(GTK_WIDGET(top_box));
		password_box=GTK_HBOX(gtk_hbox_new(false, 5));
        gtk_widget_show(GTK_WIDGET(password_box));

		LoginImage=GTK_IMAGE(gtk_image_new());
        gtk_image_set_from_file(LoginImage, image_file);
        gtk_widget_show(GTK_WIDGET(LoginImage));

		LoginText=GTK_LABEL(gtk_label_new("Login required"));
        gtk_widget_show(GTK_WIDGET(LoginText));

		UserLabel=GTK_LABEL(gtk_label_new("Username"));
        gtk_widget_show(GTK_WIDGET(UserLabel));
		PassLabel=GTK_LABEL(gtk_label_new("Password"));
        gtk_widget_show(GTK_WIDGET(PassLabel));
		UserEntry=GTK_ENTRY(gtk_entry_new());
        gtk_widget_show(GTK_WIDGET(UserEntry));
		PassEntry=GTK_ENTRY(gtk_entry_new());
        gtk_widget_show(GTK_WIDGET(PassEntry));
		handle=GTK_DIALOG(gtk_dialog_new_with_buttons("Login", NULL, GTK_DIALOG_MODAL, GTK_STOCK_OK, GTK_RESPONSE_OK, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL));


        GtkVBox *box=GTK_VBOX(gtk_dialog_get_content_area(handle));

        gtk_box_pack_start(GTK_BOX(box), GTK_WIDGET(top_box), FALSE, FALSE, 0);
        gtk_box_pack_start(GTK_BOX(box), GTK_WIDGET(user_box), FALSE, FALSE, 0);
        gtk_box_pack_start(GTK_BOX(box), GTK_WIDGET(password_box), FALSE, FALSE, 0);

        gtk_box_pack_start(GTK_BOX(top_box), GTK_WIDGET(LoginImage), FALSE, FALSE, 0);
        gtk_box_pack_start(GTK_BOX(top_box), GTK_WIDGET(LoginText), FALSE, FALSE, 0);

        gtk_box_pack_start(GTK_BOX(user_box), GTK_WIDGET(UserLabel), FALSE, FALSE, 0);
        gtk_box_pack_start(GTK_BOX(user_box), GTK_WIDGET(UserEntry), TRUE, TRUE, 0);

        gtk_entry_set_activates_default(UserEntry, TRUE);

        gtk_box_pack_start(GTK_BOX(password_box), GTK_WIDGET(PassLabel), FALSE, FALSE, 0);
        gtk_box_pack_start(GTK_BOX(password_box), GTK_WIDGET(PassEntry), TRUE, TRUE, 0);

		gtk_entry_set_visibility(PassEntry, false);
#if (!defined GTK_COMPAT_MODE) || (GTK_COMPAT_MODE<1)
        g_object_set(G_OBJECT(PassEntry), "caps-lock-warning", TRUE, NULL);
#endif
        gtk_entry_set_activates_default(PassEntry, TRUE);

        gtk_window_set_keep_above(GTK_WINDOW(handle), true);

        gtk_widget_set_size_request(GTK_WIDGET(UserLabel), 100, -1);
        gtk_widget_set_size_request(GTK_WIDGET(PassLabel), 100, -1);

        gtk_window_set_position(GTK_WINDOW(handle), GTK_WIN_POS_CENTER_ON_PARENT);
		gtk_dialog_set_default_response(handle, GTK_RESPONSE_OK);

        gtk_window_set_modal(GTK_WINDOW(handle), TRUE);

        //gtk_widget_show_all(GTK_WIDGET(handle));
}

void LoginDialog::reset(char *username, char *password, char *hint) {
        gtk_entry_set_text(UserEntry, username);
        gtk_entry_set_text(PassEntry, password);
        gtk_label_set_markup(LoginText, hint);
		gtk_widget_grab_focus(GTK_WIDGET(UserEntry));
}

void LoginDialog::hide() {
    gtk_widget_hide(GTK_WIDGET(handle));
}

int LoginDialog::run() {
    return gtk_dialog_run(handle);
}

AnsiString LoginDialog::GetPassword() {
        return AnsiString((char *)gtk_entry_get_text(PassEntry));
}

AnsiString LoginDialog::GetUsername() {
        return AnsiString((char *)gtk_entry_get_text(UserEntry));
}

LoginDialog::~LoginDialog() {
}

