#define OLDEST_WINDOWS

#include <gtk/gtk.h>

#ifdef _WIN32
    #include <gdk/gdkwin32.h>
#else
    #include <gdk/gdk.h>
#endif

#include "ConceptClient.h"
#include "AnsiList.h"
#include "base64_mime.h"
#include <iostream>
#include <time.h>

#include "splash.h"
#include "console.h"
#include "inputform.h"
//#include "html.h"
//#include <libgnome/libgnome.h>


#ifdef _WIN32
	#include <direct.h> // chdir
#endif

#include "callback.h"

#define COPYRIGHT_NOTICE    "Concept Client 1.0 (c) 2007-2010 RadGs Software (www.radgs.com)\n"\
                            "For interpreter core version 1.2.x & Concept Framework 1.2\n"\
                            "Client built using the gtk+ library (check GTK+ and dependencies licenses).\n"

#define SPLASH_IMG          "Custom/splash.jpg"
#define LOGIN_IMG           "Custom/login.gif"
#define LOADING_IMG         "Custom/loading.gif"
#define UPDATED_TXT         "Custom/update.msg"

void *chandle=0;
ConsoleWindow *_cw=0;

int used_port=DEFAULT_PORT;
int used_port_set=0;
int finished=0;
//-----------------------------------------------------------------------------------------
void update_status(bool init=false);
//-----------------------------------------------------------------------------------------
AnsiString full_cookies_path(COOKIES);

AnsiString GetCookiesPath() {
#ifdef _WIN32
    char tmp[8192];
    tmp[0]=0;
    GetTempPath(8192, tmp);
    AnsiString path(tmp);
    AnsiString full_path=path+"\\";
    full_path+=COOKIES;

    mkdir(full_path);
    return full_path;
#else
    return COOKIES;
#endif
}
long C_GetString(
        const char *lpAppName,
        const char *lpKeyName,
        const char *lpDefault,
        char *lpReturnedString,
        long nSize,
        const char * lpFileName) 
{
    FILE *in=0;
    long filesize=0;
    char *filebuffer=0;
    char section_name[4096];
    char key_name[4096];
    int error=0;

    in=fopen(lpFileName,"rb");
    if (in) {
        fseek(in, 0L, SEEK_END);
        filesize=ftell(in);
        fseek(in, 0L, SEEK_SET);
        if (filesize) {
            filebuffer=new char[filesize];
            if (filebuffer) {
                if (fread(filebuffer,1,filesize,in)==filesize) {
                    char in_name=0;
                    char in_quote=0;
                    char in_looked_section=0;
                    char in_looked_key=0;
                    char in_looked_value=0;
                    char in_comment=0;
                    char in_key=0;
                    int  temp_pos=0;
                    int key_pos=0;
                    int value_pos=0;

                    section_name[0]=0;
                    key_name[0]=0;

                    int i;
                    for (i=0;i<filesize;i++) {
                        if (in_comment) {
                            if ((filebuffer[i]=='\n') || (filebuffer[i]=='\r'))
                                in_comment=0;
                            continue;
                        }

                        if (((filebuffer[i]=='\n') || (filebuffer[i]=='\r')) && (in_looked_value)) {
                            lpReturnedString[value_pos++]=0;
                            break;
                        }

                        if (!in_quote) {
                            if ((filebuffer[i]==';') || (filebuffer[i]=='#')) {
                                if (in_looked_value)
                                    break;
                                in_comment=1;
                                continue;
                            }

                            if (filebuffer[i]=='[') {
                                // a inceput o sectziune noua, iar sectziunea precedenta este cea cautata ...
                                if (in_looked_section) {
                                    error=1;
                                    break;
                                }
                                temp_pos=0;
                                in_name=1;
                                continue;
                            }
                            if (in_name) {
                                if (filebuffer[i]==']') {
                                    in_name=0;
                                    section_name[temp_pos]=0;
                                    if (!strcmp(section_name,lpAppName))
                                        in_looked_section=1;
                                    continue;
                                }
                                if ((filebuffer[i]=='\n') || (filebuffer[i]=='\r')) {
                                    in_name=0;
                                    continue;
                                }
                                if (in_name)
                                    section_name[temp_pos++]=filebuffer[i];
                            }
                        }
                        // schimb flag-ul de ghilimele, daca le-am gasit ...
                        if (!in_name) {
                            if (filebuffer[i]=='"') {
                                in_quote=!in_quote;
                                continue;
                            }
                            if (((filebuffer[i]=='\n') || (filebuffer[i]=='\r')) && (in_quote)) {
                                in_quote=0;
                                continue;
                            }
                        }

                        if (in_looked_key) {
                           if (filebuffer[i]=='=') {
                               in_looked_value=1;
                               continue;
                           }
                           if (in_looked_value) {
                               if (value_pos<nSize-1) {
                                  if (value_pos)
                                     lpReturnedString[value_pos++]=filebuffer[i];
                                  else if ((filebuffer[i]!=' ') && (filebuffer[i]!='\t'))
                                     lpReturnedString[value_pos++]=filebuffer[i];
                               } else {
                                   lpReturnedString[value_pos++]=0;
                                   break;
                               }
                               continue;
                           }
                        }

                        if (in_looked_section) {
                            if (((filebuffer[i]>='0') && (filebuffer[i]<='9')) ||
                               ((filebuffer[i]>='a') && (filebuffer[i]<='z')) ||
                               ((filebuffer[i]>='A') && (filebuffer[i]<='Z')) ||
                               (filebuffer[i]=='_')) {
                                   if (in_key==0) {
                                       key_pos=0;
                                       in_key=1;
                                   }
                                   key_name[key_pos++]=filebuffer[i];

                               } else {
                                   if (in_key) {
                                       key_name[key_pos]=0;
                                       if (!strcmp(key_name,lpKeyName))
                                          in_looked_key=1;
                                       in_key=0;
                                   }
                               }
                            // TO DO ... sunt in sectiunea cautata ...
                        }
                    }
                    // in caz ca e ultima linie din fisier ...
                    if ((i==filesize) && (in_looked_value))
                        lpReturnedString[value_pos++]=0;
                } else
                    error=1;
            } else
                error=1;
        } else
            error=1;
        fclose(in);
    } else {
        std::cerr << "Warning: Error reading from " << lpFileName << "\n";
        error=1;
    }

    if (error)
        strncpy(lpReturnedString, lpDefault, nSize);
    return (long)in;
}
//-----------------------------------------------------------------------------
int GetKey(char *value,char *ini_name, char *section, char *key, char *def) {
   return C_GetString(section,key,def,value,1024,ini_name);
}
//-----------------------------------------------------------------------------------------
int LoadFromFile(char *file, char *buffer2, char *buffer3, char *buffer4) {
    char buffer5[0xFFF];
#ifdef PRINT_STATUS
    std::cerr << "Using shortcut " << file << "\n";
#endif
    char buffer_port[8192];
    char is_secured=0;
    char is_http=0;

    if (strstr(file,"concept:")==file)
        file+=8;

    if (strstr(file,"concepts:")==file) {
        file+=9;
        is_secured=1;
    }

    if (strstr(file,"http:")==file) {
        is_http=1;
        file+=5;
    }

    if (strstr(file,"https:")==file) {
        file+=6;
        is_http=1;
    }

    if (file[0]=='"')
        file++;
    else 
    if (((file[0]=='/') && (file[1]=='/')) || ((file[0]=='\\') && (file[1]=='\\'))) {
        file+=2;

        int len=0;

        if (file[0])
            len=strlen(file);

        int state=0;

        int buffer2_index=0;
        int buffer3_index=0;
        int port_index=0;

        if (len>8192)
            len=8192;

        for (int i=0;i<len;i++) {
            switch (state) {
                case 0:
                        if ((file[i]=='\\') || (file[i]=='/'))
                            state=2;
                        else
                        if (file[i]==':')
                            state=1;
                        else {
                            buffer2[buffer2_index++]=file[i];
                        }
                        break;
                case 1:
                        if ((file[i]>='0') && (file[i]<='9')) {
                            buffer_port[port_index++]=file[i];
                        } else
                        if ((file[i]=='\\') || (file[i]=='/'))
                            state=2;
                        break;
                case 2:
                        buffer3[buffer3_index++]=file[i];
                        break;
            }
        }

        buffer2[buffer2_index]=0;
        buffer3[buffer3_index]=0;
        buffer_port[port_index]=0;

        if (buffer_port[0]) {
            used_port=AnsiString(buffer_port).ToInt();
            if (!used_port)
                used_port=is_http ? DEFAULT_HTTP_PORT : DEFAULT_PORT;
            else
                used_port_set=1;
        }

        if (is_secured)
            strcpy(buffer4,"secured");
        else
        if (is_http)
            strcpy(buffer4,"http");
        else
            buffer4[0]=0;
        
    } else {
        int len=strlen(file);
        if ((len) && (file[len-1]=='"'))
            file[len-1]=0;

        GetKey(buffer2,file,"Shortcut","Host","localhost");
        GetKey(buffer3,file,"Shortcut","Application","start.con");
        GetKey(buffer4,file,"Shortcut","Secured","");
        GetKey(buffer5,file,"Shortcut","UseHttp","0");


        GetKey(buffer_port,file,"Shortcut","Port",AnsiString((long)DEFAULT_PORT).c_str());
        used_port=AnsiString(buffer_port).ToInt();
        if (used_port<=0)
            used_port=DEFAULT_PORT;
        else
            used_port_set=1;

        if ((buffer4[0]=='1') || (buffer4[0]=='Y') || (buffer4[0]=='y') || (buffer4[0]=='T') || (buffer4[0]=='t'))
            strcpy(buffer4,"secured");
        else
        if ((buffer5[0]=='1') || (buffer5[0]=='Y') || (buffer5[0]=='y') || (buffer5[0]=='T') || (buffer5[0]=='t'))
            strcpy(buffer4,"http");
        else
            buffer4[0]=0;
    }
    return 0;
}
//-----------------------------------------------------------------------------------------
#ifdef _WIN32
    #ifndef OLDEST_WINDOWS
        extern "C" WINBASEAPI HWND WINAPI GetConsoleWindow();
    #endif
#endif
//-----------------------------------------------------------------------------------------
void ShowConsole(int show) {
#ifdef _WIN32
    #ifndef OLDEST_WINDOWS
        static HWND hConsole=0;
        if (!hConsole)
            hConsole = GetConsoleWindow();
            //hConsole    =   GetActiveWindow();
        if (hConsole)
            ShowWindow(hConsole, show ? SW_SHOW : SW_HIDE);
    #endif
#endif
}
//-----------------------------------------------------------------------------------------
AnsiString host;
AnsiString path;
bool connected=false;
bool failed=false;
AnsiString file;
int pipestream=0;
SplashWindow *_sp=0;

THREAD_TYPE2 ConnectThread(LPVOID LPSENDER) {
	/*if (!g_thread_supported())
		g_thread_init(NULL);*/

    CConceptClient *CC=(CConceptClient *)LPSENDER;

#ifdef PRINT_STATUS
    std::cerr << "\nPowering up Concept Client ...\n";
    std::cerr << ":::::::::::::::::: Contacting server ...";
#endif
    _sp->SetProgress(0, "Contacting server ...");

    if (!used_port_set) {
        int pos=host.Pos(":");
        if (pos>1) {
            AnsiString dummy(host.c_str()+pos);
            int port=dummy.ToInt();
            if (port)
                used_port=port;
            dummy.LoadBuffer(host.c_str(), pos-1);
            host=dummy;
        }
    }
	if (CC->Connect(host,used_port)) {

#ifdef PRINT_STATUS
        std::cerr << "\r[]:::::::::::::::: Connection is now secured !";
#endif
        _sp->SetProgress(10, "Connection securized");
#ifdef PRINT_STATUS
        std::cerr << "\r[][]:::::::::::::: Running " << file;// << "\n";
#endif
        _sp->SetProgress(20, "Requesting application space ...");
        CC->Run(file,pipestream);
#ifdef PRINT_STATUS
        std::cerr << "\r[][][][][][][]:::: Loading custom controls ...                               ";
#endif
        _sp->SetProgress(75, "Loading controls ...");

#ifdef _WIN32
        LoadControls(path+COMPONENTS);
        // set path ...
        //path+=COOKIES;
        //chdir(path.c_str());
        chdir(full_cookies_path.c_str());
#else
        LoadControls(COMPONENTS_PATH);
		chdir(COOKIES_PATH);
#endif


#ifdef PRINT_STATUS
        std::cerr << "\r[][][][][][][][]:: Initializing messaging system ...                         ";
#endif
        _sp->SetProgress(90, "Initializing messaging system ...");

        CC->StartMessaging();
        CC->WaitStartup();
#ifdef PRINT_STATUS
        std::cerr << "\r[][][][][][][][][] All done. Ready !                                         \n";
#endif
        _sp->SetProgress(100, "Done !");
    }  else {
            std::cerr << "\nError connecting to server at " << host.c_str() << "\n";
            std::cerr << "\nCan't connect to specified host. Check your firewall settings or contact your network administrator.\n";

            _sp->SetProgress(100, "Error connecting...");
            TRAY_NOTIFY("Error connecting to the server", host+" cannot be contacted. Check your firewall settings or contact your network administrator.");
            failed=true;
    }
    if (_sp) {
        //_sp->hide();
        //Sleep(1000); // wait to see the splash screen
        //_sp->done_wnd();
        return NULL;
    }
    connected=true;
    return NULL;
}
//-----------------------------------------------------------------------------------------
void CreateSplash(CConceptClient *CC) {
#ifdef _WIN32
        DWORD TID;
        CreateThread(0,0,ConnectThread,CC,0,&TID);
#else
        //pthread *threadID;
        pthread_t threadID;
        pthread_create(&threadID, NULL, ConnectThread,CC);
#endif
}
//-----------------------------------------------------------------------------------------
bool out_req=false;
//-----------------------------------------------------------------------------------------
void console_print(void *data) {
    if (_cw) {
        _cw->DirectPrint((char *)data);
        _cw->show();
    }
}
//-----------------------------------------------------------------------------------------
CConceptClient *public_CC=0;
void iterate() {
    /*if (public_CC->Iterate())
        out_req=true;

    if ((out_req) || (RunApplication()!=0))
        _cw->hide();*/
}
//-----------------------------------------------------------------------------------------
// hide GTK Console
#ifndef _WIN32
void dummy_output_handler (const gchar *log_domain,
                           GLogLevelFlags log_level,
                           const gchar *message,
                           gpointer user_data)
{
    return;
}

void set_no_console() {
  g_log_set_handler(NULL, (GLogLevelFlags)(G_LOG_LEVEL_ERROR | G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_WARNING | G_LOG_LEVEL_MESSAGE | G_LOG_LEVEL_INFO | G_LOG_LEVEL_DEBUG), dummy_output_handler, NULL);
}
#endif
//-----------------------------------------------------------------------------------------
gboolean splash_idle(gpointer data) {
    SplashWindow *sp=(SplashWindow *)data;
    if (sp)
        return sp->my_idle();
    return TRUE;
}
//-----------------------------------------------------------------------------------------
gboolean my_idle(gpointer data) {
    CConceptClient *CC=(CConceptClient *)data;
    if (!CC)
        return FALSE;
    if (_cw)
        _cw->my_idle2();

    return CC->on_idle_event();
}
//-----------------------------------------------------------------------------------------
gboolean idle_run(gpointer data) {
    CConceptClient *CC=(CConceptClient *)data;
    if (!CC)
        return FALSE;

    return CC->on_idle_event();
}
//-----------------------------------------------------------------------------------------
void dialog_error(char *title, char *secondary) {
    GtkWidget *dialog=gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, "%s", title);

    gtk_window_set_keep_above(GTK_WINDOW(dialog), FALSE);
    gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
    gtk_dialog_run(GTK_DIALOG(dialog));
}
//-----------------------------------------------------------------------------------------
void update_status(bool init) {
    if (init) {
        _cw->done_wnd();
    }
    if ((failed) || (RunApplication()<0)) {
        if (!finished) {
            if (_cw)
                _cw->hide();
            gtk_main_quit();
            finished=true;
        }
        return;
    }
    /*if (failed) {
        gtk_main_quit();
        return;
    }*/
    /*if (init) {
        _cw->set_deletable(true);
        _cw->show();

        bool out=out_req;
        if ((!out) && (RunApplication()>0)) {
            GtkWindow *mainform=AppWindow();
            notify_recv_2(-2,0);
            if (mainform) {
                ShowConsole(0);
                //public_CC->NotifyStartLoop();
                ShowConsole(1);
                if (RunApplication()==1) {
                    public_CC->SendMessage("%CLIENT",MSG_APPLICATION_QUIT,"0","0");
                }
            } else {
                _cw->show();
            }
        }
    } else {
        bool out=out_req;
        if ((!out) && (RunApplication()>0)) {
            GtkWindow *mainform=AppWindow();
            if (mainform) {
                if (RunApplication()==1) {
                    public_CC->SendMessage("%CLIENT",MSG_APPLICATION_QUIT,"0","0");
                }
            } else {
                _cw->show();
            }
        } else {
            if (RunApplication()==-1) {
                gtk_main_quit();
                std::cerr << "\nAborting with run-time error(s).\n";
            } else
            if (RunApplication()<0) {
                gtk_main_quit();
            }
        }
    }*/
}
//-----------------------------------------------------------------------------------------
#ifdef _WIN32
int NotifyUpdate(AnsiString path) {
    AnsiString update_msg;
    update_msg.LoadFile(path);
    char strValue[0xFF];
    DWORD dwLength=0xFF;
    DWORD dwType=0;
    if (update_msg.Length()) {
        HKEY hk;
	    DWORD dwDisp=0;
        AnsiString msg=SLimit(update_msg.c_str(), 0xFF);

        RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\RadGs\\ConceptClient", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE | KEY_QUERY_VALUE, NULL, &hk, &dwDisp);
        
        LONG res=RegQueryValueEx(hk,"LastNotify",NULL,NULL,(LPBYTE)strValue, &dwLength);
        if ((res!=ERROR_SUCCESS) || (msg!=strValue)) {
            RegSetValueEx (hk , "LastNotify" , 0 , REG_SZ , (LPBYTE)(LPTSTR)msg.c_str() , msg.Length()+1);
            TRAY_NOTIFY("Concept://Client update", update_msg.c_str());
        }
        RegCloseKey(hk);
        return 1;
    }
    return 0;
}
#endif

int main(int argc, char **argv) {
    char buffer1[1024];
    char buffer2[1024];
    char buffer3[1024];
    char buffer4[1024];
    char buffer5[1024];
    char buffer6[1024];
    char buffer7[1024];

    buffer1[0]=0;
    buffer2[0]=0;
    buffer3[0]=0;
    buffer4[0]=0;
    buffer5[0]=0;
    buffer6[0]=0;
    buffer7[0]=0;

    for (int i=0;i<argc;i++) {
        switch (i) {
	        case 0:
		        strncpy(buffer1,argv[i],1024);
		        break;
	        case 1:
#ifdef __APPLE__
                if (!strncmp(argv[i],"-psn_",5)) {
                    argc--;
                    argv++;
                    i--;
                } else
#endif
		            strncpy(buffer2,argv[i],1024);
		        break;
	        case 2:
		        strncpy(buffer3,argv[i],1024);
		        break;
	        case 3:
		        strncpy(buffer4,argv[i],1024);
		        break;
	        case 4:
		        strncpy(buffer5,argv[i],1024);
		        break;
	        case 5:
		        strncpy(buffer6,argv[i],1024);
		        break;
	        case 6:
		        strncpy(buffer7,argv[i],1024);
		        break;
        }
    }

    //putenv("GDK_NATIVE_WINDOWS=1");
    gtk_init(0,0);

	if (!g_thread_supported())
		g_thread_init(NULL);

    full_cookies_path=GetCookiesPath();
	SetTempDir(full_cookies_path.c_str());


#ifdef _WIN32
    /* Get Icons shown on buttons */
    gtk_settings_set_long_property(gtk_settings_get_default(), "gtk-button-images", TRUE, "main");
#endif

    SetPrintCallback(console_print);

    if (argc==1) {
        // no arguments received !
        InputDialog id("Navigate to ...");
        id.reset("concept://", "Enter <b>shortcut path</b>, <b>concept(s)://</b> or <b>http(s)://</b> address");
        int x,y;
        gtk_window_get_size(GTK_WINDOW(id.handle),&x,&y);
        gtk_window_resize(GTK_WINDOW(id.handle),500,y);
        if (id.run()==GTK_RESPONSE_OK) {
            AnsiString linkpath=id.GetText();
            int len=linkpath.Length();
            if (len) {
                argc=2;
                if (len>1023)
                    len=1023;
		        strncpy(buffer2,linkpath.c_str(),len);
                buffer2[len]=0;
            }
        }
        id.hide();
    }

#ifdef PRINT_STATUS
    std::cerr << COPYRIGHT_NOTICE;    
#endif
    if (buffer2[0]==0) {
        std::cerr << "\nUsage   : " << buffer1 << " server_addres application_name [secured]";
        std::cerr << "\nExample : " << buffer1 << " localhost HelloWorld.con";
        std::cerr << "\n          or if you use a Server Shortcut file (.ss)";
        std::cerr << "\n          " << buffer1 << " shortcut.ss\n";

        /*Gtk::MessageDialog dialog("Invalid parameters received",false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_OK);
        dialog.set_keep_above(true);
        dialog.set_modal(true);
        dialog.set_secondary_text("Check the parameter syntax in the console window.");
        dialog.run();*/
        dialog_error("Invalid parameters received", "Check the parameter syntax in the console window.");
        return -1;
    } else if (buffer3[0]==0) {
        LoadFromFile(AnsiString(buffer2),buffer2,buffer3,buffer4);
    }
    srand( (unsigned)time( NULL ) );
#ifndef _WIN32
	set_no_console();
#endif

    /*AnsiString*/ host=buffer2;
    /*AnsiString*/ file=buffer3;
    AnsiString secured=buffer4;
    int is_debug=(int)(secured==(char*)"debug");
    CConceptClient::is_http=(int)(secured==(char*)"http");
    /*int*/ pipestream=AnsiString(buffer5).ToInt();

    if (file==(char*)"") {
        file=host;
        host="localhost";
    }

    CConceptClient CC(MESSAGE_CALLBACK,(int)(secured==(char*)"secured"),is_debug, (void *)notify_recv_2);
    public_CC=&CC;
    if (CC.NoErrors()) {
#ifdef _WIN32
        path=GetDirectory();
        MESSAGE_INIT(&CC,path+"conclient",host,update_status);
#else
        MESSAGE_INIT(&CC,APP_PATH,host,update_status);
#endif
            ConsoleWindow cw(iterate,false);
#ifdef _WIN32
            cw.ShowImage(path+LOADING_IMG);
#else
            cw.ShowImage(PATH_LOADING_IMG);
#endif

#ifdef _WIN32
            SplashWindow sp(path+SPLASH_IMG);
#else
            SplashWindow sp(PATH_SPLASH_IMG);
#endif

#ifdef _WIN32
            InitLoginDialog(path+LOGIN_IMG);
#else
            InitLoginDialog(PATH_LOGIN_IMG);
#endif
			InitInputDialog("Input requested");

            _sp=&sp;
            CreateSplash(&CC);

#ifdef _WIN32
            NotifyUpdate(path+UPDATED_TXT);
#endif

            //+++ sigc::connection sig_idle=Glib::signal_idle().connect(sigc::mem_fun(sp,&SplashWindow::my_idle));
            g_idle_add(splash_idle, _sp);
            _sp->run();
            g_idle_remove_by_data(_sp);
            _sp->destroy();

            _cw=&cw;
            if (failed)
                dialog_error((AnsiString("Error conecting to server at ")+host).c_str(), "Can't connect to specified host. Check your firewall settings or contact your network administrator.");
            else {
                chdir(full_cookies_path.c_str());
                g_idle_add(my_idle, &CC);
                _cw->run();
                g_idle_remove_by_data(&CC);
                _cw->done_wnd();
                _cw->set_deletable(true);
                if ((!_cw->deleted) && (!finished)) {
                    bool out=out_req;
                    ConsoleWindow cw2(iterate,true);
                    _cw=&cw2;
                    cw2.CloneData(&cw);
                    cw.destroy();

                    if ((!out) && (RunApplication()>0)) {
                        GtkWindow *mainform=AppWindow();
                        if (!mainform) {
                            _cw->show();
                        } else {
                            //gtk_widget_grab_focus(GTK_WIDGET(mainform));
	                        g_signal_connect(G_OBJECT(mainform), "delete_event", G_CALLBACK(gtk_main_quit), NULL);
                        }
                        ShowConsole(1);
                        g_idle_add(idle_run, &CC);
                        ShowConsole(0);
                        gtk_widget_show(GTK_WIDGET(mainform));
                        gtk_main();
                        if (RunApplication()==1) {
                            CC.SendMessage("%CLIENT",MSG_APPLICATION_QUIT,"0","0");
                        }
                    } else {
                        if (RunApplication()==-1) {
                            std::cerr << "\nAborting with run-time error(s).\n";
                            _cw->run();
                        }
                    }
                }
            }
    } else {
        std::cerr << "\nError loading library.\n";
    }
    QuitPending();
    std::cout.flush();
    std::cerr.flush();
    CC.Disconnect();
    UnloadControls();
    // some destructor bug ...
    exit(0);
    return 0;
}
//-----------------------------------------------------------------------------------------
// Just for the window distribution
//-----------------------------------------------------------------------------------------
#ifdef _WIN32
int __stdcall WinMain(HINSTANCE hInstance, 
                      HINSTANCE hPrevInstance, 
                      LPSTR lpCmdLine, int nShowCmd) 
{ 
  int          argc; 
  int          retVal; 
  char**       argv; 
  unsigned int i; 
  int          j; 

  // parse a few of the command line arguments 
  // a space delimites an argument except when it is inside a quote 

  argc = 1; 
  int pos = 0; 
  for (i = 0; i < strlen(lpCmdLine); i++) 
    { 
    while (lpCmdLine[i] == ' ' && i < strlen(lpCmdLine)) 
      { 
      i++; 
      } 
    if (lpCmdLine[i] == '\"') 
      { 
      i++; 
      while (lpCmdLine[i] != '\"' && i < strlen(lpCmdLine)) 
        { 
        i++; 
        pos++; 
        } 
      argc++; 
      pos = 0; 
      } 
    else 
      { 
      while (lpCmdLine[i] != ' ' && i < strlen(lpCmdLine)) 
        { 
        i++; 
        pos++; 
        } 
      argc++; 
      pos = 0; 
      } 
    } 

  argv = (char**)malloc(sizeof(char*)* (argc+1)); 

  argv[0] = (char*)malloc(1024); 
  ::GetModuleFileName(0, argv[0],1024); 

  for(j=1; j<argc; j++) 
    { 
    argv[j] = (char*)malloc(strlen(lpCmdLine)+10); 
    } 
  argv[argc] = 0; 

  argc = 1; 
  pos = 0; 
  for (i = 0; i < strlen(lpCmdLine); i++) 
    { 
    while (lpCmdLine[i] == ' ' && i < strlen(lpCmdLine)) 
      { 
      i++; 
      } 
    if (lpCmdLine[i] == '\"') 
      { 
      i++; 
      while (lpCmdLine[i] != '\"' && i < strlen(lpCmdLine)) 
        { 
        argv[argc][pos] = lpCmdLine[i]; 
        i++; 
        pos++; 
        } 
      argv[argc][pos] = '\0'; 
      argc++; 
      pos = 0; 
      } 
    else 
      { 
      while (lpCmdLine[i] != ' ' && i < strlen(lpCmdLine)) 
        { 
        argv[argc][pos] = lpCmdLine[i]; 
        i++; 
        pos++; 
        } 
      argv[argc][pos] = '\0'; 
      argc++; 
      pos = 0; 
      } 
    } 
  argv[argc] = 0; 


  // Initialize the processes and start the application. 
  retVal = main(argc, argv); 

  // Delete arguments 
  for(j=0; j<argc; j++) 
    { 
    free(argv[j]); 
    } 
  free(argv); 

  exit(retVal);
  return retVal;
}
#endif

CONCLIENT_DLL_API ConceptClientRun(void *handle, const char *host, const char *app, int secured, void *reserved) {
    int argc=0;
    char *argv[5];

    argv[0]="EmbededInstance";
    argv[1]=(char *)host;
    argv[2]=(char *)app;
    argv[3]="secured";
    argv[4]=0;

    chandle=handle;
    argc=4;
    if (secured)
        argc++;
    return main(argc, argv);
}

#ifdef _WIN32
// DLL Entry Point ... nothing ... for shared version
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
        return 1;
}
#endif
